unit Holmain;
{ Spots Holiday was one of my earlier Delphi programs. It's not very
OOPsie and I almost didn't release the source code for that reason. It has
duplicated code and globals and all that bad stuff. I did, however, work out a
SIMPLE technique for creating a bitmap mask on the fly for bitmaps that already
had a black background so I thought it would be worthwhile to release it. I'm
sure others have worked this out also, I just haven't seen it anywhere.

Anyway, if I took the time to redo the code, this would never get released...
I already missed Halloween and never got around to releasing my silly little
laughing pumpkin. Oh well.

BTW, the Paintbox is not necessary. It all works fine straight on the canvas.
I think I added it to test something and never took it out. I also use a unit
 called PREVINST which I got from the net...perhaps the mailing list. For the
 life of me, I don't know who wrote it but I thank him/her for it.

This is all free and feel free to use whatever you can from the source. If you
like it, you could drop me a note. I had fun doing it, which is really the point
anyway. There are many ways I'd like to enhance this program...not the least
of which is get employment so I can purchase ImageLib and save the pics as
something other than bulky .bmps.  Also I'm not saving what's drawn to
redraw during Paint. When Paint is called, the drawing simply starts over. I
felt it was okay for a toy such as this.

Enjoy! Sylvia Lutnes  aka  cricket@richmond.infi.net   12/95}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, HolFloat, HolAbout;

var
  OneForm : Boolean;
  Form1HeightTall : Integer;
  Form1HeightSmall : Integer;
  Ymin, Ymax : integer;
  BackColor : TColor;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    Stocking: TImage;
    Heart: TImage;
    Flake: TImage;
    Tree: TImage;
    Star: TImage;
    lblSpots: TLabel;
    lblSquares: TLabel;
    btnStop: TButton;
    BtnQuit: TButton;
    lbHidden: TListBox;
    btnClear: TButton;
    Wreath: TImage;
    Cane: TImage;
    TallTree: TImage;
    btnForm: TButton;
    btnAbout: TButton;
    btnDelete: TButton;
    Panel2: TPanel;
    Bells: TImage;
    Snowman: TImage;
    Candle: TImage;
    PaintBox1: TPaintBox;
    Shoot: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure BtnQuitClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure btnClearClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnFormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure DoShowHint(Sender: TObject);
  private
    { Private declarations }
  procedure WMGetMinMaxInfo(var Message : TWMGetMinMaxInfo); message
      WM_GETMINMAXINFO;
  procedure TransDraw(f,x,y: Integer; s: TBitmap);
  public
    { Public declarations }
    procedure SpotStop;
    procedure SpotGo;
    procedure OneFormSpots(s : string);
    Procedure TwoFormSpots(s : string);
    Procedure DrawBitmaps(s : string; f : integer);
    procedure OneFormShoot;
    procedure TwoFormShoot;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WMGetMinMaxInfo(var Message : TWMGetMinMaxInfo);
begin
  with Message.MinMaxInfo^ do
  begin
    if Ymax <> 0 then begin
      ptMinTrackSize.X := 505;
      ptMinTrackSize.Y := Ymin;
      ptMaxTrackSize.X := 505;
      ptMaxTrackSize.Y := Ymax;
    end
    else begin
      ptMinTrackSize.X := 505;
      ptMinTrackSize.Y := Ymin;
      ptMaxTrackSize.X := 505;
    end;
  end;
  Message.Result := 0;
  inherited;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
  i, k : integer;
  s : string;
begin
  if lbHidden.Items.Count > 0 then
    begin
      if lbHidden.Items.Count = 1 then i := 0
          else i := random(lbHidden.Items.Count);
      s := lbHidden.Items[i];
      if ((s = 'Spots') or (s = 'Squares')) then
        begin
          for k := 0 to 5 do begin
            if OneForm then OneFormSpots(s) else TwoFormSpots(s);
            Application.ProcessMessages;
          end;
        end
        else if (s = 'Pine') then
        begin
           if OneForm then OneFormShoot else TwoFormShoot;
           Application.ProcessMessages;
        end
        else begin
        if OneForm then DrawBitmaps(s,1) else DrawBitmaps(s,2);
        end;
    end;
  Application.ProcessMessages;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  if btnStop.Caption = '&Stop'
    then SpotStop
    else SpotGo;
end;

procedure TForm1.SpotStop;
begin
  Timer1.Interval := 0;
  btnStop.Caption := '&Go';
  if not OneForm then Form2.btnStopGo.Caption := '&Go';
end;

procedure TForm1.SpotGo;
var
  l : longint;
begin
  if OneForm then begin
    with PaintBox1 do begin
    {Canvas.Brush.Color := RGB(Random(64),Random(64),Random(64));}
    {Canvas.Brush.Color := RGB(Random(255),Random(255),Random(255));
    l := ColorToRGB(Canvas.Brush.Color);
    Canvas.Brush.Color := $02000000 or l;
    BackColor := Canvas.Brush.Color;}
    Canvas.Brush.Color := clBlack;
    Canvas.FillRect(Rect(0,0,ClientWidth,ClientHeight));
    end;
    end else begin
      with Form2.PaintBox2 do begin
        {Canvas.Brush.Color := RGB(Random(64),Random(64),Random(64));}
        {Canvas.Brush.Color := RGB(Random(255),Random(255),Random(255));
        l := ColorToRGB(Canvas.Brush.Color);
        Canvas.Brush.Color := $02000000 or l;
        BackColor := Canvas.Brush.Color;}
        Canvas.Brush.Color := clBlack;
        Canvas.FillRect(Rect(0,0,ClientWidth,ClientHeight));
        Form2.btnStopGo.caption := '&Stop';
      end;
    end;
  btnStop.Caption := '&Stop';
  Timer1.Interval := 60;
end;

procedure TForm1.BtnQuitClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Canvas.Brush.Color := BackColor;
  Canvas.FillRect(Rect(0,0,ClientWidth,ClientHeight));
  {SpotGo;}
end;

procedure TForm1.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := True;
end;

procedure TForm1.FormDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  i : integer;
begin
  if source is Timage
    then i := lbHidden.items.add((Source as TImage).name)
    else i := lbHidden.items.add((Source as TLabel).caption);
  if not OneForm then btnForm.Click;
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
  SpotStop;
  if OneForm then begin
    Canvas.Brush.Color := clBlack;
    Canvas.FillRect(Rect(0,0,ClientWidth,ClientHeight));
  end else
    with Form2.PaintBox2 do begin
      Canvas.Brush.Color := clBlack;
      Canvas.FillRect(Rect(0,0,ClientWidth,ClientHeight));
    end;
  lbHidden.Clear;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  randomize;
end;

procedure TForm1.btnFormClick(Sender: TObject);
begin
  OneForm := False;
  Ymin := Form1HeightSmall;
  Ymax := Form1HeightSmall;
  Form1.Height := Form1HeightSmall;
  Form2.Visible := True;
end;

procedure TForm1.OneFormSpots(s : string);
var
  x, y, x1, y1, size : Integer;
  l : longint;
const
  shadow = Tcolor(clBlack);
begin
  with PaintBox1 do begin
  Canvas.CopyMode := cmSrcCopy;
  Canvas.Pen.width := 1 + Random(2);
  x := Random(ClientWidth);
  x1 := x + 2;
  y := Random(ClientHeight);
  y1 := y + 2;
  size := Random(10)+ 5;
  Canvas.Brush.color := shadow;
  Canvas.Pen.color := shadow;
  if s = 'Spots' then Canvas.Ellipse(x1,y1,x1+size,y1+size)
    else  Canvas.Rectangle(x1,y1,x1+size,y1+size);
  Canvas.Pen.color := RGB(Random(128), Random(128), Random(128));
  l := ColorToRGB(Canvas.Pen.Color);
  Canvas.Pen.Color := $02000000 or l;
  Canvas.Brush.Color := ($02000000  or trunc($ffffff*random));
  if s = 'Spots' then Canvas.Ellipse(x,y,x+size,y+size)
    else Canvas.Rectangle(x,y,x+size,y+size);
  end;
end;

procedure TForm1.TwoFormSpots(s: string);
var
  x, y, x1, y1, size : Integer;
  l : longint;
const
  shadow = Tcolor(clBlack);
begin
  with Form2.PaintBox2 do begin
  Canvas.CopyMode := cmSrcCopy;
  Canvas.Pen.width := 1 + Random(2);
  x := Random(ClientWidth);
  x1 := x + 2;
  y := Random(ClientHeight);
  y1 := y + 2;
  size := Random(10)+ 5;
  Canvas.Brush.color := shadow;
  Canvas.Pen.color := shadow;
  if s = 'Spots' then Canvas.Ellipse(x1,y1,x1+size,y1+size)
    else  Canvas.Rectangle(x1,y1,x1+size,y1+size);
  Canvas.Brush.Color := ($02000000  or trunc($ffffff*random));
  Canvas.Pen.color := RGB(Random(128), Random(128), Random(128));
  l := ColorToRGB(Canvas.Pen.Color);
  Canvas.Pen.Color := $02000000 or l;
  if s = 'Spots' then Canvas.Ellipse(x,y,x+size,y+size)
    else Canvas.Rectangle(x,y,x+size,y+size);
  end;
end;

procedure TForm1.DrawBitmaps(s : string; f  : integer);
var
  x,y : integer;
begin
  if (f = 1) then
  with PaintBox1 do begin
  x := Random(ClientWidth);
  y := Random(ClientHeight);
  end
  else with Form2.PaintBox2 do begin
  x := Random(ClientWidth);
  y := Random(ClientHeight);
  end;
  if s = 'Cane' then TransDraw(f,X,Y,Cane.Picture.Bitmap)
    else if s = 'Wreath' then TransDraw(f,X,Y,Wreath.Picture.Bitmap)
      else if s = 'TallTree' then TransDraw(f,X,Y,TallTree.Picture.Bitmap)
        else if s = 'Tree' then TransDraw(f,X,Y,Tree.Picture.Bitmap)
          else if s = 'Flake' then TransDraw(f,X,Y,Flake.Picture.Bitmap)
            else if s = 'Heart' then TransDraw(f,X,Y,Heart.Picture.Bitmap)
              else if s = 'Star' then TransDraw(f,X,Y,Star.Picture.Bitmap)
                else if s = 'Stocking' then TransDraw(f,X,Y,Stocking.Picture.Bitmap)
                  else if s = 'Candle' then TransDraw(f,X,Y,Candle.Picture.Bitmap)
                    else if s = 'Snowman' then TransDraw(f,X,Y,Snowman.Picture.Bitmap)
                      else if s = 'Bells' then TransDraw(f,X,Y,Bells.Picture.Bitmap);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1HeightTall := Form1.Height;
  Form1HeightSmall := Panel1.Height
      + Panel2.Height
      + (Form1.Height - Form1.ClientHeight);
  OneForm := True;
  Application.OnHint := DoShowHint;
  Ymin := 230;
  Ymax := 0;
  BackColor := clBlack;
end;

procedure TForm1.btnAboutClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
begin
  if lbHidden.items.count > 0 then begin
    lbHidden.Items.Delete(lbHidden.ItemIndex);
  end;
end;

procedure TForm1.DoShowHint(Sender: TObject);
begin
  Panel2.Caption := Application.Hint;
end;

procedure TForm1.OneFormShoot;
var
  i : integer;
  x,y : integer;
begin
  With PaintBox1.Canvas do begin
  Pen.Width := 1;
  x := Random(ClientWidth) - 40;
  y := Random(ClientHeight) - 40;
  Pen.Color := clGreen;
    for i := 1 to 12 do begin
      MoveTo(x,y);
      LineTo(x+Random(40),y+Random(40));
    end;
  end;
end;

procedure TForm1.TwoFormShoot;
var
  i : integer;
  x,y : integer;
begin
  With Form2.PaintBox2.Canvas do begin
  Pen.Width := 1;
  x := Random(Form2.PaintBox2.ClientWidth) - 20;
  y := Random(Form2.PaintBox2.ClientHeight) - 20;
  Pen.Color := clGreen;
    for i := 1 to 12 do begin
      MoveTo(x,y);
      LineTo(x+Random(40),y+Random(40));
    end;
  end;
end;

{I got the idea for this routine from Carl Mes and from Mark Johnson
  via the Delphi Talk Mailing List. After a lot of experimentation, I
  came up with the code for the mask. All my bitmaps have a black
   background so this works great! I didn't have to draw any separate
   masks to include with the program!}

procedure TForm1.TransDraw(f,x,y: Integer; s: TBitmap);
var
  oldcol : longint;
  MyMask : tBitmap;
  dest,src : Trect;
begin
   MyMask := TBitmap.create;
   try
    with MyMask do begin  {First create mask}
        width := s.width;
        height := s.height;
        oldcol := SetBkColor(canvas.handle,colorToRGB(clWhite));
        dest := canvas.ClipRect;
        src := s.canvas.ClipRect;
        canvas.Brushcopy(dest,s,src,clBlack); {copy pic in}
      end;
      if f = 1 then with PaintBox1.canvas do
        begin
          CopyMode := cmSrcAnd;
          draw(x,y,MyMask);
          CopyMode := cmSrcPaint;
          Draw(x,y,s);
        end
        else with Form2.PaintBox2.canvas do
        begin
          CopyMode := cmSrcAnd;
          draw(x,y,MyMask);
          CopyMode := cmSrcPaint;
          Draw(x,y,s);
        end;
   finally
    mymask.free;
   end;
end;


end.
